"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.rateLimiterFilterProvider = exports.RateLimiterFilter = void 0;
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const asserter_interface_1 = require("./asserter.interface");
const too_many_requests_exception_1 = require("./too-many-requests.exception");
const set_headers_fn_1 = require("./utils/set-headers.fn");
let RateLimiterFilter = class RateLimiterFilter extends core_1.BaseExceptionFilter {
    catch(exception, host) {
        const response = host.switchToHttp().getResponse();
        // in case of `fastify` get native response via `res` property
        // https://www.fastify.io/docs/latest/Reply/#introduction
        // in case of `express` response inherit native response
        const nativeResponse = response.raw || response;
        (0, set_headers_fn_1.setHeaders)(nativeResponse, exception.limiterInfo);
        nativeResponse.setHeader('Retry-After', (exception.limiterInfo.reset - Date.now() / 1000) | 0);
        return super.catch(new too_many_requests_exception_1.TooManyRequestsException(JSON.parse(exception.message)), host);
    }
};
RateLimiterFilter = __decorate([
    (0, common_1.Catch)(asserter_interface_1.RateLimiterError)
], RateLimiterFilter);
exports.RateLimiterFilter = RateLimiterFilter;
exports.rateLimiterFilterProvider = {
    provide: core_1.APP_FILTER,
    useClass: RateLimiterFilter,
};
//# sourceMappingURL=filter.js.map